Auto Multiple Choice - Bug # 348: AMC fails to identify scans

Status: Closed Priority: Normal

Author: Jose Goicolea Category:

Created: 04/18/2015 Assignee:

Updated: 04/23/2015 Due date:

Description: | am using auto-multiple-choice version 1.2.1_1 on OS-X macports version 2.3.3. It has been working fine up

to now, but it now fails to analyse the scans and identify the layouts and zooms. | guess this is probably due tq
the upgrade of some of the modules for analysing the images but | cannot find out which.

| enclose a debug .log file when analysing one of the scans, it fails to identify it according to the layouts.

I have copied the same project directory to a linux ubuntu machine and there it worked fine, without
problems.

History

04/22/2015 09:01 am - Jose Goicolea
- File AMC-bug-report.zip added

Further information to facilitate the analysis of this error:

* The error occurs only in the macports version (Mac OS X 10.7.5), probably due to some of the auxiliary system programs.
* | have prepared a slimmed-down project which reproduces the error, in a directory called "k".

* | include screensave files showing the error on mac OSX and the correct processing of the same project on linux ubuntu.
* | also include the log files for both systems.

All the files together with the .AMC.d configuration directory are included as a .zip package

Any help would be very welcome!

04/22/2015 09:12 am - Alexis Bienveniie

On MacOSX, can you type the following command in a terminal?

<pre>

/opt/local/lib/AMC/exec/AMC-detect -x 2480.31494396015 -y 3507.87397260274 -d 42.519511994409 -p 0.2-m 0.2 -t 0.6 -0 1
</pre>

It should not return, but let you type some commands: type

<pre>

load /Users/goico/AMC/k/scans/t6_0000.tif

</pre>

(followed by <return>) and tell us if you get any output.

04/22/2015 09:44 am - Jose Goicolea

Thanks for the attention, here is the result of these commands:

<pre>

goico@trueno:~/AMCS$ /opt/local/lib/AMC/exec/AMC-detect -x 2480.31494396015 -y 3507.87397260274 -d 42.519511994409 -p 0.2-m 0.2-t 0.6 -0 1
TX=2480.31 TY=3507.87 DIAM=42.52

load /Users/goico/AMC/k/scans/t6_0000.tif

Segmentation fault: 11

goico@trueno:~/AMC$

</pre>
04/22/2015 11:02 am - Alexis Bienveniie

Can you test the same with @gdb@?

<pre>

gdb --args /opt/local/lib/AMC/exec/AMC-detect -x 2480.31494396015 -y 3507.87397260274 -d 42.519511994409 -p 0.2-m 0.2 -t 0.6 -0 1
</pre>

then, type @run@ at the @(gdb)@ prompt, and continue like before.

04/22/2015 11:24 am - Jose Goicolea
- File gdb-output.txt added

Thanks, | attach the output using gdb in a separate file

04/22/2015 11:46 am - Alexis Bienveniie
What is the output of @backtrace@ inside @gdb@ after the crash?

04/22/2015 02:05 pm - Jose Goicolea
here is the output of backtrace:

<pre>

load /Users/goico/AMC/k/scans/t6_0000.tif

Program received signal EXC_BAD_ACCESS, Could not access memory.
Reason: KERN_INVALID_ADDRESS at address: 0x000000010730e180
0x0000000100618adc in put1bitbwtile ()

(gdb) backtrace

#0 0x0000000100618adc in putibitbwtile ()

#1 0x00000001006167b0 in gtStripContig ()

#2 0x000000010061453d in TIFFReadRGBAStrip ()

#3 0x000000010028a264 in cv::TiffDecoder::readData ()

#4 0x000000010026da9a in cv::iimread_ ()

#5 0x000000010027151f in cvLoadlmage ()

#6 0x00000001000053be in main ()

(gdb)

</pre>

04/22/2015 02:43 pm - Alexis Bienveniie
It seems that the problem comes from OpenCV (using @cvLoadlmage@ to load your TIF scan file)...

Is it possible to try with another version of the OpenCV port (you will have to recompile AMC)?

04/22/2015 07:45 pm - Jose Goicolea
Great!! the problem is solved, many, many thanks.

The opencv port in macports was updated recently to version 2.4.11_0, the previous version from 5 months ago was 2.4.10_0. | downloaded the older
version and installed it, deactivating the newer version, as can be seen:
<pre>
goico@trueno:~$ port installed opencv
The following ports are currently installed:
opencv @2.4.10_0 (active)
opencv @2.4.11_0
goico@trueno:~$
</pre>

Then | uninstalled auto-multiple-choice and installed it again (I'm not sure this is necessary, just in case). After this everything works fine as it used to!!
Many thanks for your great help. AMC is a really fantastic tool and we use it a lot in our group at the technical university of Madrid. So we are really

grateful, and even more so taking into account the attention to solving problems like these.

Best regards

04/22/2015 08:21 pm - Alexis Bienveniie
- % Done changed from 0 to 100

- Status changed from New to Closed

> Great!! the problem is solved
Good.
However, it could be interesting to see what is the problem with opencv @2.4.11_0, and report it to MacPorts or OpenCV. Can you send me the scan

file, so that | can have a look one day?

04/22/2015 11:16 pm - Jose Goicolea
- File t6_0000.tif added

Of course, | enclose the scan as an attached file.

| could report it also to MacPorts, but | don't know how to reproduce the task directly from opencv calls. If you can give me this info | can undertake to

report the problem

04/23/2015 02:06 pm - Alexis Bienveniie
- File load.c added

Attached is a simple program to use @cvLoadlmage@.

Compile it with something like (I am not sure if the options are the right ones for MacOSX — compare with the arguments used when compiling
@AMC-detect.cc@ from AMC):

<pre>

gcc -l/opt/local/include/opencyv -lopencv_core -lopencv_highgui load.c -o load
</pre>

And call (with the scan file in the same directory)

<pre>

Jload t6_0000.tif

</pre>

Can you make this work with opencv @2.4.10_0?

Can you reproduce the problem with opencv @2.4.11_0?

04/23/2015 05:51 pm - Jose Goicolea
OK, done. Firstly, the compilation command | have used is

<pre>
gcc -l/opt/local/include/opencyv -l/opt/local/include -L/opt/local/lib -lopencv_core -lopencv_highgui -lopencv_imgproc load.c -o load

</pre>

This compiles successfully for both versions of opencv (@2.4.10_0 and @2.4.11_0). It runs OK under version @2.4.10_0, however no output is printed
on the terminal. Under version @2.4.11_0 it fails with "Segmentation fault: 11". The gdb output in this case is:
<pre>

Program received signal EXC_BAD_ACCESS, Could not access memory.
Reason: KERN_INVALID_ADDRESS at address: 0x000000010720e180
0x000000010060dadc in put1bitbwtile ()
(gdb) backtrace

#0
#1
#2
#3
#4
#5
#6

0x000000010060dadc in put1bitbwtile ()
0x000000010060b7b0 in gtStripContig ()
0x000000010060953d in TIFFReadRGBAStrip ()
0x000000010027f264 in cv::TiffDecoder::readData ()
0x0000000100262a9a in cv::iimread_ ()
0x000000010026651f in cvLoadlmage ()
0x000000010000322b in main ()

(gdb)
</pre>

| guess this would be ok to report the problem for opencv in macports right?

Regards

04/23/2015 06:21 pm - Jose Goicolea

OK, I have reported the problem to macports, the ticket number is https:/trac.macports.org/ticket/47549

04/23/2015 08:52 pm - Alexis Bienveniie
Very good! Did you try with other TIF files, coming from elsewhere?

04/23/2015 10:53 pm - Jose Goicolea
- File k.tif added

you're right, with other tiff files it seems to work ok. For instance, with this file which is converted from a jpg file | don't get an error. | guess tiff files can

be quite different.

Files

AMC-DEBUG-oDibkuKY.log 64 kB 04/18/2015 Jose Goicolea
AMC-bug-report.zip 800 kB 04/22/2015 Jose Goicolea
gdb-output.txt 1.2kB 04/22/2015 Jose Goicolea
t6_0000.tif 25.7 kB 04/22/2015 Jose Goicolea
load.c 147 Bytes 04/23/2015 Alexis Bienvenle
k.tif 490 kB 04/23/2015 Jose Goicolea
